# MacroService

{% hint style="warning" %}
MacrosService will be removed in the next version.
{% endhint %}

Defines the MacroService, which is an access to operations involving `IMacro`.

[Browse the API documentation for IMacroService interface](https://apidocs.umbraco.com/v13/csharp/api/Umbraco.Cms.Core.Services.IMacroService.html).

* **Namespace:** `Umbraco.Cms.Core.Services`
* **Assembly:** `Umbraco.Core.dll`

All samples in this document will require references to the following dll:

* Umbraco.Core.dll

```csharp
using Umbraco.Cms.Core.Services;
```

For Razor views:

```csharp
@using Umbraco.Cms.Core.Services
```

## Getting the service

### Dependency Injection

If you wish to use the macro service in a class, you need to specify the `IMacroService` interface in your constructor:

```csharp
public class MyClass
{
    private IMacroService _macroService;

    public MyClass(IMacroService macroService)
    {
        _macroService = macroService;
    }
}
```

In Razor views, you can access the macro service through the `@inject` directive:

```csharp
@inject IMacroService MacroService
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.umbraco.com/umbraco-cms/13.latest/reference/management/services/macroservice.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
